      * Interface pour la programmation des SOCKETS
      * (C)2001 by Paul TOTH <tothpaul@free.fr>

     -*-Const---------------------------------------------------------------------------------------
     D Internet        c                   Const(2)
     D Stream          c                   Const(1)
     D NULL            c                   Const(X'00')
     D CRLF            c                   Const(X'0D0A')
     D SOL_SOCKET      c                   Const(-1)
     D SO_REUSEADDR    c                   Const( 4)

     -*-Function socket(Family,Type,Protocol:integer):integer;--------------------------------------
     D Socket          pr            10I 0 ExtProc('socket')
     D  Family                       10I 0 Value
     D  Type                         10I 0 Value
     D  Protocol                     10I 0 Value

     -*-Function close(Handle:integer):integer;-----------------------------------------------
     D Close           pr            10I 0 ExtProc('close')
     D  Socket                       10I 0 Value

     -*-Function setsockopt(Socket,Range,Option:integer; Value:pointer; ValueSize:integer):integer;-
     D SetSockOpt      pr            10I 0 ExtProc('setsockopt')
     D  Socket                       10I 0 Value
     D  Range                        10I 0 Value
     D  Option                       10I 0 Value
     D  Value                          *   Value
     D  ValueSize                    10I 0 Value

     -*-Function Bind(socket:Integer;Var SockAddr:TSockAddr;Var Size:integer):integer;--------------
     D Bind            pr            10I 0 ExtProc('bind')
     D  Socket                       10I 0 Value
     D  SockAddr                       *   Value
     D  AddrSize                     10I 0 Value
     D  Error                          *

     -*-Function Listen(Socket,Flags:integer):integer;----------------------------------------------
     D Listen          pr            10I 0 ExtProc('listen')
     D  Socket                       10I 0 Value
     D  Flags                        10I 0 Value

     -*-Function Accept(Socket:integer; Var SockAddr:TSockAddr; Var Size:integer):integer;----------
     D Accept          pr            10I 0 ExtProc('accept')
     D  Socket                       10I 0 Value
     D  SockAddr                       *   Value
     D  AddrSize                     10I 0

     -*-Function connect(Socket:Integer;Var SockAddr:TSockAddr;Var Size:integer):integer;-----------
     D Connect         pr            10I 0 ExtProc('connect')
     D  Socket                       10I 0 Value
     D  SockAddr                       *   Value
     D  AddrSize                     10I 0 Value

     -*-Function getservbyname(Name:PChar;Proto:Pchar):PServEnt;------------------------------------
     D GetServByName   pr              *   ExtProc('getservbyname')
     D  Service                        *   Value options(*string)
     D  Protocol                       *   Value options(*string)

     -*-Function gethostbyname(Host:PChar)PHostEnt;-------------------------------------------------
     D GetHostByName   pr              *   ExtProc('gethostbyname')
     D  HostName                       *   Value options(*string)

     -*-Function recv(HSocket:integer;Var Buffer;Size,Flags:integer):integer;-----------------------
     D Recv            pr            10I 0 ExtProc('recv')
     D  Socket                       10I 0 Value
     D  Buffer                         *   Value
     D  MaxSize                      10I 0 Value
     D  Mode                         10I 0 Value

     -*-Function Send(HSocket:integer;Var Buffer;Size,Flags:integer):integer;-----------------------
     D Send            pr            10I 0 ExtProc('send')
     D  Socket                       10I 0 Value
     D  Buffer                         *   Value
     D  Size                         10I 0 Value
     D  Mode                         10I 0 Value

     -*-Function shutdown(HSocket,How:integer):integer;---------------------------------------------
     D ShutDown        pr            10I 0 ExtProc('shutdown')
     D  Socket                       10I 0 Value
     D  How                          10I 0 Value

     -*-Function inet_ntoa(var in:in_addr):pchar;---------------------------------------------------
     D INet_NToA       pr              *   ExtProc('inet_ntoa')
     D  In_Addr                      10U 0 Value

     -*-Function inet_addr(addr:pchar):longint;-----------------------------------------------------
     D INet_Addr       pr            10U 0 ExtProc('inet_addr')
     D  Addr                           *   Value options(*string)

      * Type SockAddr=Record
      *  Family:word;
      *  Port:word;
      *  Addr:longint;
      *  Zeros:array[0..7] of byte;
      * end;
     D PSockAddr       s               *   inz(%addr(SockAddr))
     D SockAddr        ds
     D  saFamily                      5U 0
     D  saPort                        5U 0
     D  saAddr                       10U 0
     D  saZero                        8    inz(X'0000000000000000')

     D PServEnt        s               *
     D TServEnt        ds                  Based(PServEnt)
     D  seName                         *
     D  seAlias                        *
     D  sePort                       10I 0
     D  seProtocol                     *

     D PHostEnt        s               *
     D THostEnt        ds                  Based(PHostEnt)
     D  heName                         *
     D  heAlias                        *
     D  heType                       10I 0
     D  heAddrSize                   10I 0
     D  heAddrList                     *
     D HostAddr        s               *   Based(heAddrList)

     -*-Function CallServer(Name:PChar;Port:integer):integer;---------------------------------------
     D CallServer      pr            10I 0
     D  Name                           *   Value options(*string)
     D  Port                         10U 0 Value

     -*-Function CallIPServer(Addr:PChar;Port:integer):integer;-------------------------------------
     D CallIPServer    pr            10I 0
     D  Addr                           *   Value options(*string)
     D  Port                         10U 0 Value

     -*-Function StartServer(Port,MaxClient:integer):integer;--------------------------------------
     D StartServer     pr            10I 0
     D  Port                         10I 0 Value
     D  MaxClient                    10I 0 Value

     -*-Procedure CloseSocket(Socket:integer);------------------------------------------------------
     D CloseSocket     pr
     D  Socket                       10I 0

     -*-Function WaitClient(Socket:integer);--------------------------------------------------------
     D WaitClient      pr            10I 0
     D  Socket                       10I 0

     -*-Procedure WriteLn(Socket:integer; str:PChar);-----------------------------------------------
     D WriteLn         pr            10I 0
     D  Socket                       10I 0
     D  String                     1024    Value

     -*-Procedure ReadLn(Socket:integer; str:PChar);-----------------------------------------------
     D ReadLn          pr            10I 0
     D  Socket                       10I 0
     D  String                     1024
