program rmtcmd;

{
 Remote Command for AS/400
 Copyright (C) 2001  Paul Toth <tothpaul@free.fr>
 http://tothpaul.free.fr

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

}

uses
  windows, shellapi,
  crtsock in 'CrtSock.pas',
  RegEdit in 'RegEdit.pas';

Const
// Dmarrage automatique
 Key='Software\Microsoft\Windows\CurrentVersion\Run';
 Tag='Software\Borland';
 Ver='2.1';
 Version='RMTCMD v2.1 by Paul TOTH <tothpaul@free.fr>';
 Local='C:\PROGRAM FILES\RMTCMD.EXE';

var
 Server:integer;
 sin,sout:TextFile;

 Client:integer;
 Addr:string;
 i:integer;
 ok:boolean;
 s:string;

procedure ToUpper(var s:string);
 var
  i:integer;
 begin
  for i:=1 to length(s) do s[i]:=upcase(s[i]);
 end;

function HostName:string;
 var
  s:array[0..255] of char;
 begin
  if gethostname(s,255)=0 then result:={trim}(s) else result:='unknow';
 end;

// IP
Function LocalIPAddress:string;
 var
  h:PHost;
 begin
  h:=gethostbyname(pchar(HostName));
  if h<>nil then result:=LongToIp(longint(h^.addr^^)) else result:='?.?.?.?';
 end;

Function CurrentUserName:string;
 var
  Size:integer;
 begin
  size:=255;
  SetLength(Result,Size);
  if GetUserName(pchar(Result),Size) then SetLength(Result,Size-1) else Result:='unknow';
 end;

procedure ShowFile(FileName:string);
 var
  f:textfile;
 begin
  writeln(sout,'[',FileName,']');
  try
   assign(f,FileName);
   reset(f);
   while not eof(f) do begin
    readln(f,s);
    writeln(sout,s);
   end;
   close(f);
  except
   writeln(sout,'not found');
  end;
  Writeln(sout);
 end;

procedure DisplayConfig;
 begin
  FileMode:=0;
  showfile('c:\autoexec.bat');
  showfile('c:\config.sys');
 end;

procedure Remove;
 begin
  DeleteRegString(HKEY_LOCAL_MACHINE,Tag,'RmtCmd');
  DeleteRegString(HKEY_LOCAL_MACHINE,Key,'Remote command');
 end;

Procedure Administrator;
 const
  HELP='VER = server version'#13#10+
       'WHO = current username'#13#10+
       'CFG = display config files'#13#10+
       'RMV = remove server from windows registration'#13#10+
       'END = end remote serveur'#13#10+
       'BYE = exit';
 begin
  WriteLn(sout,'PASSWORD');
  ReadLn(sin,s);
  if s<>'678' then exit;
  WriteLn(sout,'OK - ',CurrentUserName);
  Readln(sin,s);
  ToUpper(s);
  while s<>'BYE' do begin
   if s='VER' then Writeln(sout,version) else
   if s='WHO' then Writeln(sout,CurrentUserName) else
   if s='CFG' then DisplayConfig else
   if s='RMV' then begin Remove; WriteLn(sout,'OK'); end else
   if s='END' then exit else
   if s='HELP' then WriteLn(sout,Help) else
   writeln(sout,'??');
   ReadLn(sin,s);
   ToUpper(s);
  end;
 end;

procedure Install;
 var
  fs,fd:file;
  data:pointer; datasize:longint;
  s:string;
  i:integer;
 begin
  // Copier en local
  filemode:=1; assignfile(fd,Local); rewrite(fd,1); // WriteOnly
  if ioresult<>0 then begin // erreur de copie - on fera la mise  jour au prochain boot
   remove;
   exit;
  end;
  filemode:=0; assignfile(fs,ParamStr(0)); reset(fs,1); // ReadOnly
  if ioresult<>0 then exit; // on a vraiment pas de chance
  datasize:=filesize(fs);
  getmem(data,datasize);
  blockread(fs,data^,datasize);
  blockwrite(fd,data^,datasize);
  freemem(data,datasize);
  closefile(fs);
  closefile(fd);
  // mettre  jour la registration
  s:=Local;
  for i:=1 to paramcount do s:=s+' '+paramstr(i);
  WriteRegString(HKEY_LOCAL_MACHINE,Key,'Remote command',s);
  WriteRegString(HKEY_LOCAL_MACHINE,Tag,'RmtCmd',VER);
 end;

begin
 // Copier en Local
 if ParamStr(0)<>Local then begin
  Install;
  exit;
 end;

 // Dmarrer le server 678
 Server:=StartServer(678);
 if Server=-1 then exit;

 // Attendre un client
 Client:=WaitClientEx(Server,Addr);

 While Client<>-1 do begin

 // N'autoriser que les adresses en paramtre
  ok:=(paramcount=0);
  for i:=1 to paramcount do begin
   s:=paramstr(i);
   ok:=copy(addr,1,length(s))=s;
   if ok then break;
  end;
  if ok then begin
  // grer l'Input/Output
   AssignCrtSock(Client,sin,sout);
  // envoyer OK
   WriteLn(sout,'OK');
  // lire la rponse
   ReadLn(sin,s);
  // tant que pas BYE
   While s<>'BYE' do begin
   // mode administrateur
    if s='ADMIN' then begin
     Administrator;
     if s='END' then break;
    end else begin
   // mode normal : executer la commande
     if WinExec(pchar(s),SW_SHOW)<=31 then WriteLn(sout,'NO') else WriteLn(sout,'OK');
     ReadLn(sin,s);
    end;
   end;
  end;

  Disconnect(Client);
  if s='END' then Client:=-1 else Client:=WaitClientEx(Server,Addr);

 end;

 Disconnect(Server);
end.
